/*!F::Debug procedures - main implementation file.
 *
 *  ::Purpose:
 *    Detect bugs and inform programmer about them.
 *
 *    It is part of error handling facilities which involve error.s, debug.c and
 *    faults.c.
 *    It covers programmers mistakes: bad argument passed, wrong code reached,
 *    bad use of programming facility.
 *    It doesn't cover OS errors (errors.c) and user's errors (faults.c).
 *
 *  ::Goals:
 *    - thread-safe, reentrant, portable (POSIX systems)
 *    - buffer/integer overflow safe
 *    - propagate or handle errors with routines from "errors.h"
 *
 *  ::Functionality:
 *    - log messages
 *    - log messages if condition true
 *    - log variable values
 *
 *  ::Limitations:
 *    - definitely more debug routines can be implemented
 *
 *  ::Properties:
 *    compiler options:   -std=c99
 *    thread safe
 *
 *  ::Other:
 *    File:             This file is part of program distributed under GNU General Public License.
 *                      For terms of distribution, warranty and licensing see README file.
 *    Created:          2013-12-16
 *    (c) Copyright:    Maciej Helminiak 2013
 *    License:          GNU General Public License, version 3
 *                      Copy of the license is distributed along with this program
 *                      or can be seen at <http://www.gnu.org/licenses/>
 */




/* current project */
#include "common_mhlbase.h"

/* mh library */
#include "core.h"
#include "logs.h"

/* libc */

/* current module */
#include "debug.h"
