#ifndef MHCL_BASE_SRCBASE_FAULTS_INTER_H_INC
#define MHCL_BASE_SRCBASE_FAULTS_INTER_H_INC

/*!F::User's faults - internal interface file.
 *
 *  ::Provides functions for basic manipulations of this module data structures.
 */




/* employs includes from arrptrs.c */




/*!:: Labels for enumeration constants in 'faultcath_en'.
 * :: Printable, unmodifiable string literals describing each enum constant.
 *    Constant itself can be used as index in this array.
 */
static const char* const faultcath_Labels[faultcath_count] = {
   "none",
   "ignore",
   "continue",
   "exit",
   "abort",
};




static inline
uint
extend_ (
   st_faults_arr* stFaultsArr,
   uint nels_add
){
   size_t nels_total = stFaultsArr->na + nels_add;
   st_fault** buf = stFaultsArr->buf;  //helper var
   if (buf == NULL) {
      buf = mem_alloc(sizeof(*buf) * nels_total);
   } else {
      buf = mem_reallocz(buf, sizeof(*buf) * stFaultsArr->na, sizeof(*buf) * nels_total);
   }
   if (buf == NULL) {   //: error
      nels_total = 0;
   } else {             //: success
      stFaultsArr->buf = buf;
      stFaultsArr->na = nels_total;
   }
   return nels_total;
}



#endif /*- MHCL_BASE_SRCBASE_FAULTS_INTER_H_INC -*/
