#ifndef MHCL_BASE_SRCCONTAINERS_ARRPTRS_H
#define MHCL_BASE_SRCCONTAINERS_ARRPTRS_H

/*!F::Array of pointers - external interface file.
 *
 *  ::Provides function declarations for other modules.
 */




/* current project */
#include "common_mhlbase.h"
#include "logs.h"

/* mh library */
#include "core.h"
#include "errors.h"
#include "debug.h"

/* libc */
#include <stdlib.h>     // abort()
#include <stdio.h>      // printf(), fflush()




typedef void* (*arr_ptrs_el_destr_ft)(void*,void*);


typedef struct arr_ptrs_t arr_ptrs_t;
/*!:: Array of pointers of any type.
 */
struct arr_ptrs_t
{
   void** buf;    //! array of pointers
   uint ns;       //! elements set
   uint na;       //! elements allocated
   arr_ptrs_el_destr_ft pf_el_destr;  //! destroy pointed objs when finalizing struct with this fun
};
#define ARR_PTRS_T_Z (arr_ptrs_t){NULL,0,0,NULL}




extern void arrptrs_ini (arr_ptrs_t* arrptrs, arr_ptrs_el_destr_ft pf_el_destr)
               __attr_nonnull__(1)
               ;

extern void arrptrs_ini2 (arr_ptrs_t* arrptrs, uint nels_init, arr_ptrs_el_destr_ft pf_el_destr)
               __attr_nonnull__(1)
               ;

extern void arrptrs_ext (arr_ptrs_t* arrptrs, uint nels_add)
               __attr_nonnull__(1)
               ;

extern void* arrptrs_fin (arr_ptrs_t* arrptrs, void* destr_data)
               __attr_nonnull__(1)
               ;

extern void* arrptrs_cpy (arr_ptrs_t* arrptrs, uint idx, void* ptr)
               __attr_nonnull__(1)
               ;

//extern void* arrptrs_cpyr (arr_ptrs_t* arrptrs, uint idx, uint num, void* ptr)
               //__attr_nonnull__(1)
               //;

extern void* arrptrs_app ( arr_ptrs_t* arrptrs, void* ptr)
               __attr_nonnull__(1)
               ;

extern void* arrptrs_el_ret (arr_ptrs_t* arrptrs, uint idx)
               __attr_nonnull__(1)
               ;

extern void* arrptrs_it (const arr_ptrs_t* arrptrs, uint* idx)
               __attr_nonnull__(1,2)
               ;




#ifdef DEBUG
bool arrptrs_all_tests_run (void)
      __attr_wures__
      ;
#endif




#endif /*- MHCL_BASE_SRCCONTAINERS_ARRPTRS_H -*/
