/*!F::Vector data structure - main implementation file.
 *
 *  ::Purpose:
 *
 *  ::Goals:
 *    - thread-safe, reentrant, portable (POSIX systems)
 *    - buffer/integer overflow safe
 *    - propagate or handle errors with routines from "errors.h"
 *
 *  ::Functionality:
 *
 *  ::Limitations:
 *
 *  ::Properties:
 *    compiler options:   -std=c99
 *    thread safe
 *
 *  ::Other:
 *    File:             This file is part of program distributed under GNU General Public License.
 *                      For terms of distribution, warranty and licensing see README file.
 *    Created:          2014-04-15
 *    (c) Copyright:    Maciej Helminiak 2014
 *    License:          GNU General Public License, version 3
 *                      Copy of the license is distributed along with this program
 *                      or can be seen at <http://www.gnu.org/licenses/>
 */




/* mh library */
#include "core.h"

/* current project */
#include "common_mhlbase.h"
#include "errors.h"

/* libc */
//#include <errno.h>         // errno
//#include <stdarg.h>        // va_*
//#include <stdio.h>         // printf(), fflush()
//#include <string.h>        // strerror()

/* current module */
#include "vector.h"
