/*!F::String operations - main implementation file.
 *
 *  ::Purpose:
 *    Various string operations.
 *
 *  ::Goals:
 *    - thread-safe, reentrant, portable (POSIX systems)
 *    - buffer/integer overflow safe
 *
 *  ::Functionality:
 *
 *  ::Limitations:
 *
 *  ::Properties:
 *    compiler options:   -std=c99
 *    thread safe
 *
 *  ::Other:
 *    File:             This file is part of program distributed under GNU General Public License.
 *                      For terms of distribution, warranty and licensing see README file.
 *    Created:          2014-05-11
 *    (c) Copyright:    Maciej Helminiak 2014
 *    License:          GNU General Public License, version 3
 *                      Copy of the license is distributed along with this program
 *                      or can be seen at <http://www.gnu.org/licenses/>
 */




/* current project */
#include "common_mhlbase.h"

/* mh library */
#include "core.h"
#include "errors.h"
#include "debug.h"
//#include "memory.h"
#include "strings.h"
#include "strings_arr.h"

/* libc */

/* current module */
#include "string_operations.h"
#include "string_operations_internal.h.inc"
#include "string_operations_aux.h.inc"




/* Perform brace expansion and place results in specified strings array.
   Result is multiplication of each comma separated string inside braces by
   strings outside braces.
   ENOMEM
   errors not covered properly !!!
 */
void
str_expand_braces (
   strarr_t* sarr,      //! [out] resulting strings
   const str_t* str     //! string to expand
){
   ___Dassert(sarr, "'sarr' parameter invalid");
   ___Dassert(str, "'str' parameter invalid");
   expand_braces(sarr, str, true);
   return;
}
