/* This file is part of program distributed under GNU General Public
   License. For more information see README and LICENSE files. */

#ifndef MHCL_BASE_SRCSTRINGS_STRINGOPS_H
#define MHCL_BASE_SRCSTRINGS_STRINGOPS_H

/*!F::String operations - external interface file.
 *
 *  ::Provides function declarations for other modules.
 */




/* current project */
#include "common_mhlbase.h"

/* mh library */
#include "core.h"
//#include "errors.h"
//#include "debug.h"
#include "strings.h"
#include "strings_arr.h"

/* libc */




/* Brace {} expansion. */
extern void str_expand_braces (strarr_t* sarr, const str_t* str)
               __attr_nonnull__(1,2)
               ;

#define BypassBlanks(STR) while (isblank(*(STR))) { ++(STR); }  //: skip all blanks
#define BypassSpaces(STR) while (isspace(*(STR))) { ++(STR); }  //: skip all spaces
#define BypassBlanksC(STR,COUNT) while (isblank(*(STR))) { ++(STR); ++(COUNT); }
#define BypassSpacesC(STR,COUNT) while (isspace(*(STR))) { ++(STR); ++(COUNT); }



#endif /*- MHCL_BASE_SRCSTRINGS_STRINGOPS_H -*/
