#ifndef MHCL_FS_SRCDIRS_DS_BASIC_H
#define MHCL_FS_SRCDIRS_DS_BASIC_H


/*!F::Basic operations on directory streams - external interface file.
 *
 *  ::Provides functions for other program modules.
 */




/* current project */
#include "common_mhlfs.h"

/* mh library */
#include "core.h"
#include "errors.h"
#include "debug.h"

/* libc */
#include <dirent.h>     // opendir(), DIR, struct dirent




/*!1:: Open a directory. */
extern DIR* ds_open (const char* dirname)
            __attr_nonnull__(1)
            __attr_wures__
            ;

/*!1:: Close a directory. */
extern void ds_close (DIR** dirstream)
            __attr_nonnull__(1)
            ;

/*!1:: Compute maximum length of entry name. */
extern long file_name_len (const DIR* dirstream)
            __attr_nonnull__(1)
            __attr_wures__
            ;




#ifdef DEBUG
/* Used only by tests in debug mode. */
extern bool dsbas_all_tests_run (void)
      __attr_wures__;
#endif




#endif /*- MHCL_FS_SRCDIRS_DS_BASIC_H -*/
