/* This file is part of program distributed under GNU General Public
   License. For more information see README and LICENSE files. */

#ifndef MHCL_FS_SRCDIRS_DS_INFO_AUX_H_INC
#define MHCL_FS_SRCDIRS_DS_INFO_AUX_H_INC


/*!F::Directories information retrieve - auxillary file.
 *
 *  ::Provides helper functions for main implementation file.
 */




/* employs includes from ds_info.c */




/*!1:: Perform globbing on given pattern. */
static inline size_t dirent_st_size (const DIR* dirstream)
                     __attr_nonnull__(1)
                     ;




/*!:: Compute size of libc entry structure 'struct dirent' for given directory
 *    stream. Size depends on file system entry name maximum length.
 * ::Preconditions:
 *    None.
 * ::Errors:
 *    No errors.
*/
static inline
size_t                  //! libc entry structure size
dirent_st_size (
   const DIR* ds        //! directory stream
){
   ___Dassert(ds, "'ds' parameter invalid");

   /*: Get maximum length of entry name. */
   long max_namelen = file_name_len(ds);
      if (max_namelen == -1) { max_namelen = 1024; }
      ___Dassert(max_namelen > 1, "'max_namelen' intermediate value invalid");

   /*: Get struct size and return: */
   size_t struct_size = 0;
   struct_size = (size_t)offsetof(struct dirent, d_name) + max_namelen + 1;
      ___Dassert(struct_size >= (size_t)(max_namelen+1), "'struct_size' intermediate value invalid");
   return (struct_size > sizeof(struct dirent)
            ? struct_size
            : sizeof(struct dirent));
}




#endif /*- MHCL_FS_SRCDIRS_DS_INFO_AUX_H_INC -*/
