/* This file is part of program distributed under GNU General Public
   License. For more information see README and LICENSE files. */

#ifndef MHCL_FS_SRCIOSTR_FSTREAM_BASIC_H
#define MHCL_FS_SRCIOSTR_FSTREAM_BASIC_H

/*!F::File stream basic functions - external interface file.
 *
 *  ::Provides functions for other program modules.
 */




/* current project */
#include "common_mhlfs.h"

/* mh library */
#include "core.h"
#include "errors.h"
//#include "debug.h"




/*!1:: Open filestream for given file name. */
extern void fs_open (FILE** pfs, const char* fname, const char* mode)
         __attr_nonnull__(1,2)
         ;

/*!1:: Close given filestream. */
extern void fs_close (FILE** pfs)
         __attr_nonnull__(1)
         ;




#ifdef DEBUG
/* Used only by tests in debug mode. */
extern bool fsbasic_all_tests_run (void)
      __attr_wures__;
#endif




#endif /*- MHCL_FS_SRCIOSTR_FSTREAM_BASIC_H -*/
