#ifndef MHCL_FS_SRCSTATS_STAT_CHANGE_H
#define MHCL_FS_SRCSTATS_STAT_CHANGE_H


/*!F::File statistics change - external interface file.
 *
 *  ::Provides functions for other program modules.
 */




/* current project */
#include "common_mhlfs.h"

/* mh library */
#include "core.h"
#include "errors.h"
#include "debug.h"

/* libc */
#include <sys/stat.h>   // chmod()




/*!1:: Change file permissions. */
extern void stat_chmod (const char* file, mode_t num_mode, const char* cstr_mode)
               __attr_nonnull__(1)
               ;

/*!1:: Change file owner - user. */
extern void stat_chusr (const char* file, uid_t uid, const char* cstr_user)
               __attr_nonnull__(1)
               ;

/*!1:: Change file owner - group. */
extern void stat_chgrp (const char* file, gid_t gid, const char* cstr_group)
               __attr_nonnull__(1)
               ;




#ifdef DEBUG
/* Used only by tests in debug mode. */
extern bool statchange_all_tests_run (void)
      __attr_wures__;
#endif




#endif /*- MHCL_FS_SRCSTATS_STAT_CHANGE_H -*/
