#ifndef MHCL_PRCONF_SRCPARS_PRCONFPARS_H
#define MHCL_PRCONF_SRCPARS_PRCONFPARS_H


/*!F::Command-line arguments parser - external interface file.
 *
 *  ::Provides functions for other program modules.
 */




/* current project */
#include "common_prconf.h"
#include "clarg_storage.h.inc"

/* mh library */
#include "core.h"
#include "errors.h"
#include "faults.h"




extern void cla_parse_clargs (st_specs_arr* stArgSpecs, char* argv[], int argc,
                              st_faults_arr* Faults)
               __attr_nonnull__(1,2,4)
               ;

extern void cla_parse_conffile (st_specs_arr* stArgSpecs, const char* fname,
                              st_faults_arr* Faults)
               __attr_nonnull__(1,2,3)
               ;

extern void cla_parse_shellvar (st_specs_arr* stArgSpecs, const char* varname,
                              st_faults_arr* Faults)
               __attr_nonnull__(1,2,3)
               ;

extern void cla_validate_arguments (st_specs_arr* stArgSpecs, st_faults_arr* Faults)
               __attr_nonnull__(1,2)
               ;

extern void cla_print_set_arguments (st_specs_arr* stArgSpecs)
               __attr_nonnull__(1)
               ;

extern bool cla_opt_is_set (st_specs_arr* stArgSpecs, uint opt_id)
               __attr_nonnull__(1)
               ;

extern bool cla_oper_is_set (st_specs_arr* stArgSpecs, uint oper_id)
               __attr_nonnull__(1)
               ;

extern int cla_ret_opt_lvl (st_specs_arr* stArgSpecs, uint opt_id)
               __attr_nonnull__(1)
               ;

extern char* cla_ret_opt_value (st_specs_arr* stArgSpecs, uint opt_id, uint vn)
               __attr_nonnull__(1)
               ;

extern char* cla_ret_oper_value (st_specs_arr* stArgSpecs, uint oper_id, uint vn)
               __attr_nonnull__(1)
               ;

extern strarr_t* cla_ret_opt_values_arr (st_specs_arr* stArgSpecs, uint opt_id)
                  __attr_nonnull__(1)
                  ;




#ifdef DEBUG
/* Used only by tests in debug mode. */
extern bool parser_all_tests_run (void)
      __attr_wures__;
#endif


#endif /*- MHCL_PRCONF_SRCPARS_PRCONFPARS_H -*/
