/* This file is part of program distributed under GNU General Public
   License. For more information see README and LICENSE files. */

#ifndef MHCL_PRCONF_SRCSPEC_PRCONFSPEC_INTER_H_INC
#define MHCL_PRCONF_SRCSPEC_PRCONFSPEC_INTER_H_INC


/*!F::Command-line arguments specificator - internal interface file.
 *
 *  ::Provides functions for basic manipulations of data structures in this
 *    module.
 */




/* employs includes from prconf_spec.c */




static inline
st_opt_spec*
optspec_constr_ (
   uint id,
   behopt_en beh,
   const char* sname,
   const char* lname,
   sint vn_min,
   sint vn_max,
   strarr_t* p_vv,
   bool mand
){
   st_opt_spec* new = mem_alloc(sizeof(*new));
      HandleErr(HANDLE_ERR);

   new->id = id;
   new->beh = beh;
   str_ini(&new->sname, sname);
   str_ini(&new->lname, lname);
      HandleErr(HANDLE_ERR);
   new->vn_min = vn_min;
   new->vn_max = vn_max;
   new->p_vv = p_vv;
   new->mand = mand;

   new->lvl = 0;
   sarr_ini2(&new->vals, 0);

   return new;

  HANDLE_ERR:
   return NULL;
}

static inline
void
optspec_destr_ (
   st_opt_spec** pstOptSpec
){
   st_opt_spec* osp = *pstOptSpec;
   str_fin(&osp->sname);
   str_fin(&osp->lname);
   sarr_fin(&osp->vals);
   mem_free(*pstOptSpec);
   return;
}

static inline
st_oper_spec*
operspec_constr_ (
   uint id,
   sint vn_min,
   sint vn_max,
   strarr_t* p_vv,
   bool mand
){
   st_oper_spec* new = mem_alloc(sizeof(*new));
      HandleErr(HANDLE_ERR);

   new->id = id;
   new->vn_min = vn_min;
   new->vn_max = vn_max;
   new->p_vv = p_vv;
   new->mand = mand;

   sarr_ini2(&new->vals, 0);

   return new;

  HANDLE_ERR:
   return NULL;
}

static inline
void
operspec_destr_ (
   st_oper_spec** pstOptSpec
){
   st_oper_spec* osp = *pstOptSpec;
   sarr_fin(&osp->vals);
   mem_free(*pstOptSpec);
   return;
}










#endif /*- MHCL_PRCONF_SRCSPEC_PRCONFSPEC_INTER_H_INC -*/
