#ifndef TFMAN_SRCACTS_PARS_ACTIONS_H
#define TFMAN_SRCACTS_PARS_ACTIONS_H


/*!F::Tfman file system actions - external interface file.
 *
 *  ::Provides functions for other program modules.
 */




/* mh library */
#include "core.h"
#include "errors.h"

/* current project */
#include "common_tfman.h"
#include "parse_acts.h"

/* current module */

/*
   arr_ptrs_t arrActKinds[acttype_count];  //! array of pointers to actions

   acttype_en kind;   //! kind of action
   strarr_t fnames;  //! canonical filenames (prepared, after brace expansion and globbing)
   str_t oper;       //! operand
*/

/*!1:: Present action to user.. */
extern size_t acts_sift_and_present_to_user (const st_actions_table* stTable,
                        const st_parser_main* stParsMain)
               __attr_nonnull__(1,2)
               ;

extern void acts_perform (st_actions_table* stTable)
               __attr_nonnull__(1)
               ;




#ifdef DEBUG
/* Used only by tests in debug mode. */
extern bool acts_all_tests_run (void)
      __attr_wures__;
#endif




#endif /*- TFMAN_SRCACTS_PARS_ACTIONS_H -*/
