/* This file is part of Tfman, program distributed under GNU General Public
   License. For more information see README and LICENSE files. */

/* current project */
#include "common_tfman.h"

/* mh library */
#include "core.h"
#include "errors.h"
#include "debug.h"
#include "cstrings.h"

/* libc */
#include <stdio.h>   // printf()
#include <string.h>  // strcmp()

/* current module */
#include "opts.h"
#include "opts_internal.h.inc"
//#include "opts_aux.h.inc"




static
bool
opts_usage_pattern (int argc, char* argv[])
{
   printf("\t:: TEST: starting %s\n", __func__);

   bool succ = true;
   uint test_num = 1;
   uint test_variant = 1;

  tests_start:
   if (test_num == 1)   // usage
   {
      if (test_variant == 1) {

      goto common_checks;
      }
   }

   if (test_num == 2) { // END
      goto ret;
   }

   ++test_num;
   test_variant = 1;
   goto tests_start;

  common_checks:
   if (succ == true) printf("\t:: TEST: number %d variant %d done\n", test_num, test_variant);
   ++test_variant;
   goto tests_start;

  ret:
   return succ;

  handle_abort:
   abort();
}


bool
opts_all_tests_run (int argc, char* argv[])
{
   bool succ = true;
   printf("starting Tests in %s\n", __FILE__);

   if (!opts_usage_pattern(argc, argv)) { succ = false; }
   //if (!opts_internal_interface_test()) { succ = false; }
   //if (!opts_set_cleanup_test()) { succ = false; }

   if (succ == true) {
      printf("TESTS:: %s: Tests PASSED\n\n", __FILE__); }
   else {
      printf("TESTS:: %s: ! Tests FAILED\n\n", __FILE__); }

   return succ;
}
