/* This file is part of Tfman, program distributed under GNU General Public
   License. For more information see README and LICENSE files. */

#ifndef TFMAN_SRCREPTXT_REP_TEXT_AUX_H_INC
#define TFMAN_SRCREPTXT_REP_TEXT_AUX_H_INC


/*!F::File system text representation - auxillary file.
 *
 *  ::Provides helper functions for main implementation file.
 */




/* employs includes from image.c */





/*!1:: Forge line with name of directory scanned. */
//TO REMOVE
//static inline void forge_dirname_line (st_fstxt* stFsTxt)
 //                    __attr_nonnull__(1)
  //                   ;

/*!1:: Forge lines with entries. */
static inline void forge_other_lines (st_fstxt* stFsTxt)
                     __attr_nonnull__(1)
                     ;

/*!1:: Forge lines with entries in block layout. */
static inline void forge_lines_as_block (st_fstxt* fs_text_repr,
      str_t* dirname, st_imgent* first_entry, uint num_entries,
      st_tfman_opts* options, uint indent, st_imgent_aux* stLon)
                     __attr_nonnull__(1,2,3,5,7)
                     ;

#if 0
/*!1:: NOT IMPL - Forge lines with entries in tree layout. */
static inline void forge_lines_as_tree (st_fstxt* fs_text_repr,
      const char* dirname, st_imgent* first_entry, uint num_entries,
      st_tfman_opts* options, uint indent)
                     __attr_nonnull__(1,2,3,5)
                     ;
#endif

/*!1:: Forge single line with entry. */
static inline char* forge_entry_line (st_imgent* current_entry, str_t* dname,
      st_ent_format* format, st_tfman_opts* stOpts, uint indent,
      strarr_t* prefstrs, strarr_t* otherstrs, st_imgent_aux* aux_info)
                     __attr_nonnull__(1,2,3,6,7,8)
                     ;





/*!:: Create directory name from information in image representation and add
 *    '/'.
 * ::Errors:
 *    ENOMEM         -- no memory available
 */
// TO REMOVE
//static inline
//void
//forge_dirname_line (
   //st_fstxt* stFsTxt       //! [out] file system text representation
//){
   //___Dassert(stFsTxt, "'stFsTxt parameter invalid");
//
   //st_fsimg* stFsImg = stFsTxt->stFsImg;
   //stFsTxt->l_top_dname = cs_cref("%s", stFsImg->filename.buf);
      //HandleErr(handle_err);
//
   ///*: Finish: */
   //return;
//
  //handle_err:
   //return;
//}

/*!:: Forge directory text representation. Use block or tree layout -
 *    accordingly to options in image representation.
 * ::Errors:
 *    forge_lines_as_block()  -- this function errors
 *    forge_lines_as_tree()   -- this function errors
 */
static inline
void
forge_other_lines (
   st_fstxt* stFsTxt       //! [out] file system text representation
){
   ___Dassert(stFsTxt, "'stFsTxt parameter invalid");

   st_fsimg* stFsImg = stFsTxt->stFsImg;

   layout_en lay = stFsImg->stOpts->layout;
   if (lay == Lay_block)      //: layout block
   {
      forge_lines_as_block(stFsTxt, &stFsImg->filename,
         stFsImg->_subentry_first, stFsImg->n_entrs, stFsImg->stOpts, 0, &stFsImg->_longest);
         HandleErr(handle_err);
   }
   else if (lay == Lay_tree)  //: layout tree
   {
#if 0
      forge_lines_as_tree(stFsTxt, stFsImg->filename.buf,
         stFsImg->_subentry_first, stFsImg->n_entrs, stFsImg->stOpts, 0);
#endif
         HandleErr(handle_err);
   }
   else  // never should be here
   {
      ___Sentinel("Wrong layout value");
   }

   /*: Finish: */
   return;

  handle_err:
   return;
}

/*!:: Forge directory text representation in block layout. Prepend with
 *    directory name, compose line for each entry, compose additional block
 *    representation for each entry that is directory and has subentries
 *    recorded.
 * ::Errors:
 *    ENOMEM               -- no memory available
 *    fstxt_expand_()      -- this function errors
 *    forge_entry_line()   -- this function errors
 */
static inline
void
forge_lines_as_block (
   st_fstxt* stFsTxt,         //! [out] file system text representation
   str_t* dname,         //! directory name where scanning was performed
   st_imgent* stEnt_fst,      //! tfman entries tree (image of dir)
   uint n_entrs,              //! number of entries
   st_tfman_opts* stOpts,     //! options
   uint ind,                  //! indentation width
   st_imgent_aux* stLon       //! longest field names in this directory
){
   ___Dassert(stFsTxt, "'stFsTxt' parameter invalid");
   ___Dassert(dname, "'dname' parameter invalid");
   ___Dassert(stEnt_fst, "'stEnt_fst' parameter invalid");
   ___Dassert(stOpts, "'stOpts' parameter invalid");
   ___Dassert(stLon, "'stLon' parameter invalid");

   /* ....................................................................... */
   /*: Check how many lines needed and expand if necessary */
   //size_t nlns_need = n_entrs + 1 + 1;     //1 empty line, 1 dirname line
   size_t nlns_need = n_entrs + 1;     //1 empty line, 1 dirname line
   size_t space = stFsTxt->nptrs - stFsTxt->nlns;
   if (nlns_need > space) {
      size_t expand_by = nlns_need - space;
      if (expand_by < 4096) { expand_by = 4096; }
      fstxt_expand_(stFsTxt, expand_by);
   }

   /* ....................................................................... */
   /*: Add empty line */
   stFsTxt->lines[stFsTxt->nlns] = cs_cre("");
      HandleErr(handle_err);

   /*: Add dirname line */
      /*
   stFsTxt->lines[stFsTxt->nlns+1] = cs_cref("%*s%s %s%s%s",
         ind, "", sarr_el_ret(&stFsTxt->prefstrs, PSTR_DIRBLK),
         sarr_el_ret(&stFsTxt->otherstrs, 0), dname->buf, sarr_el_ret(&stFsTxt->otherstrs, 1));
      HandleErr(handle_err);
      */

   /* ....................................................................... */
   /*: Compose lines representing entries: */
   size_t first_idx = stFsTxt->nlns+1;    //: first free line in text repr struct
   size_t last_idx = first_idx + n_entrs; //: last line to use for last entry
   /*: For each line representing entry: */
   st_imgent* stCur_ent = stEnt_fst;
   for (size_t i = first_idx; i < last_idx; ++i) {
      //: Forge representation
      stFsTxt->lines[i] = forge_entry_line(stCur_ent, dname, &stOpts->stFormat,
            stOpts, ind,
            &stFsTxt->prefstrs, &stFsTxt->otherstrs, stLon);
         HandleErr(handle_err);
      //: Fetch next entry
      stCur_ent = stCur_ent->_next;
   }
   stFsTxt->nlns += nlns_need;

   /* ....................................................................... */
   /*: Forge separate block of text repr for each entry that is dir: */
   stCur_ent = stEnt_fst;
   for (size_t i = 0; i < n_entrs; ++i) {
      //: If is dir and has subentries:
      if (stCur_ent->type == 'd' && stCur_ent->_subentry_first != NULL) {
         //: Forge representation (whole block):
         forge_lines_as_block(stFsTxt,
               &stCur_ent->filename, stCur_ent->_subentry_first,
               stCur_ent->n_entrs, stOpts, ind+stOpts->indent, &stCur_ent->_longest);
            HandleErr(handle_err);
      }
      //: Fetch next entry
      stCur_ent = stCur_ent->_next;
   }

   /*: Finish: */
   return;

  handle_err:
   return;
}

#if 0
/*!:: NOT IMPL YET
 * Forge directory text representation in tree layout.
 * ::Errors:
 *    No errors.
 */
static inline
void
forge_lines_as_tree (
   st_fstxt* stFsTxt,      //! [out] file system text representation
   const char* dname,
   st_imgent* stEnt_fst,      //! file system image
   uint n_entrs,
   st_tfman_opts* stOpts,
   uint ind                 //! indentation width
){
   ___Dassert(stFsTxt, "'stFsTxt' parameter invalid");
   ___Dassert(dname, "'dname' parameter invalid");
   ___Dassert(stEnt_fst, "'stEnt_fst' parameter invalid");
   ___Dassert(stOpts, "'stOpts' parameter invalid");

   goto handle_err;

    /*: Finish: */
   return;

  handle_err:
   return;
}
#endif

/*!:: Forge directory text representation in block layout. Prepend with
 *    directory name, compose line for each entry, compose additional block
 *    representation for each entry that is directory and has subentries
 *    recorded.
 * ::Errors:
 *    ENOMEM               -- no memory available
 *    fstxt_expand_()      -- this function errors
 *    forge_entry_line()   -- this function errors
 */
static inline
char*
forge_entry_line (
   st_imgent* stCur_ent,      //! entry data
   str_t* dname,         //! parent directory name
   st_ent_format* stFormat,   //! fields used to compose entry
   st_tfman_opts* stOpts,     //! options
   //bool clone_names,          //! add second field with name
   uint ind,                  //! indentation width
   strarr_t* prefstrs,        //! tags for block, tree layout and active entry
   strarr_t* otherstrs,       //! action tags
   st_imgent_aux* stLon       //! longest values of entry fields
){
   ___Dassert(stCur_ent, "'stCur_ent' parameter invalid");
   ___Dassert(dname, "'dname' parameter invalid");
   ___Dassert(stFormat, "'stFormat' parameter invalid");
   ___Dassert(prefstrs, "'prefstrs' parameter invalid");
   ___Dassert(otherstrs, "'otherstrs' parameter invalid");
   ___Dassert(stLon, "'stLon' parameter invalid");

   char* line_new = NULL;
   st_imgent* stEntr = stCur_ent;

   /* ....................................................................... */
   /*: Determine line type: */

   //: If entry is directory that couldn't be read:
   if (stEntr->type == '0') {
      //: compose entry from explanation that was placed in name:
      line_new = cs_cref("%*s%s", ind, "", stEntr->entryname.buf);
         HandleErr(handle_err);
      goto handle_succ;
   }


  /* ....................................................................... */
  /*: Start line with effective line prefix: */
  char* dname_ltarget = NULL;

  if (stEntr->entryname.buf[0] == '.' && stEntr->entryname.buf[1] == '\0') {
    //: DIR entry if '.'
    char t = stat_file_type_is(dname->buf, false);
    if (t == 'l') {
      //: it is link to dir, get it's target
      stat_readlink(&dname_ltarget, 0, dname->buf); //: on error assign NULL, means that link couldn't be read
        HandleErr(handle_err);
    }
      //: add to computed longest entry names
      mbstate_t state = {0};
      size_t len = dname->nc;
      const char* cstr = dname->buf;
      size_t mlen = mbsrtowcs(NULL, &cstr, len, &state);
      if (mlen > stLon->name) { stLon->name = mlen; }
      dname->mnc = mlen;

      line_new = cs_cref("%s%*s", sarr_el_ret(prefstrs, PSTR_DIRBLK), ind, "");
      str_repls(&stEntr->entryname, dname);
   } else {
      //: ACTIVE LINE entry otherwise
      line_new = cs_cref("%s%*s", sarr_el_ret(prefstrs, PSTR_ENTRY_ACTIVE), ind, "");
      //line_new = cs_cref("%*s%s", ind, "", sarr_el_ret(prefstrs, PSTR_ENTRY_ACTIVE));
   }
         HandleErr(handle_err);

   /*: Auxillary struct - state of line being forged */
   struct st_fstxt_forge_line_state
   {
      bool used[format_count];   //: format fields already used
   };
   struct st_fstxt_forge_line_state stState = { {0} };

   /* ....................................................................... */
   /*: Compose each format field in order of appearance in array inside format
       struct: */
   for (size_t i = 0; i < stFormat->els; ++i) {

      /*: Get ready: */
      size_t shift = 0;
      format_en format_field = stFormat->EFormat[i];        //: subsequent format field
      if (stState.used[format_field] == true) { continue; } //: ignore if field already composed

      /*: Add field: */
      cs_appf(&line_new, "%s", sarr_el_ret(otherstrs, OSTR_SPACE));  //: space
         HandleErr(handle_err);
      switch (format_field)
      {
         case Format_name:
            if (stEntr->type == 'd') {
               //: for dirs add / at end
              shift = stEntr->entryname.nc - stEntr->entryname.mnc;
               cs_appf(&line_new, "%s%*s/%s", sarr_el_ret(otherstrs, OSTR_NAME_BEG),
                  (int)(stLon->name+shift), stEntr->entryname.buf,
                  sarr_el_ret(otherstrs, OSTR_NAME_END));
            } else {
               //: other lines
              shift = stEntr->entryname.nc - stEntr->entryname.mnc;
               cs_appf(&line_new, "%s%*s%s ", sarr_el_ret(otherstrs, OSTR_NAME_BEG),
                   (int)(stLon->name+shift), stEntr->entryname.buf,
                   sarr_el_ret(otherstrs, OSTR_NAME_END));
            }
            if (stOpts->clone_names == true) {
              shift = stEntr->entryname.nc - stEntr->entryname.mnc;
               cs_appf(&line_new, "  %-*s", (int)(stLon->name+shift), stEntr->entryname.buf);
            }
            break;
         case Format_type:
            cs_appf(&line_new, "%c", stEntr->type);
            break;
         case Format_perms:
            cs_appf(&line_new, "%s", stEntr->perms);
            break;
         case Format_user:
            shift = stEntr->owner[0].nc - stEntr->owner[0].mnc;
            cs_appf(&line_new, "%-*s", (int)(stLon->user+shift), stEntr->owner[0].buf);
            break;
         case Format_group:
            shift = stEntr->owner[1].nc - stEntr->owner[1].mnc;
            cs_appf(&line_new, "%-*s", (int)(stLon->group+shift), stEntr->owner[1].buf);
            break;
         case Format_lntarget:
            if (dname_ltarget != NULL) { //: for top dirs that are links

              //: add to computed longest targets names
              mbstate_t state = {0};
              size_t len = strlen(dname_ltarget);
              const char* cstr = dname_ltarget;
              size_t mlen = mbsrtowcs(NULL, &cstr, len, &state);
              if (mlen > stLon->lntar) { stLon->lntar = mlen; }

              //: compose ltarget field
              cs_appf(&line_new, "%c%s%-*s", 'd', sarr_el_ret(otherstrs,OSTR_TARGET), (int)(stLon->lntar), dname_ltarget);
              cs_des(&dname_ltarget);
            }
            else if (stEntr->type == 'l') { //: for links
               char* cs_lntar = stEntr->lntar.buf;

               if (cs_lntar == NULL)   //couldn't read symlnik content
               {
                  cs_appf(&line_new, "%s%*s", sarr_el_ret(otherstrs,OSTR_TARGET), (int)(stLon->lntar), "?");
               }
               else                    //target was read
               {
                  char* cs_lntar_absname = NULL;
                  if (cs_lntar[0] == '/') {
                    cs_lntar_absname = cs_cref("%s", cs_lntar);
                  } else {
                    cs_lntar_absname = cs_cref("%s/%s", dname->buf, cs_lntar);
                  }

                  char type = stat_file_type_is(cs_lntar_absname, true);
                     HandleErr(handle_err);
                  switch (type) {
                  case 'N':   // non-existant
                     cs_appf(&line_new, "%s%-*s", sarr_el_ret(otherstrs,OSTR_TARGET_NEX), (int)(stLon->lntar), cs_lntar);
                     break;
                  case '\0':  // error reading type
                     cs_appf(&line_new, "%c%s%-*s", '?', sarr_el_ret(otherstrs,OSTR_TARGET), (int)(stLon->lntar), cs_lntar);
                     break;
                  default:    // type read
                     cs_appf(&line_new, "%c%s%-*s", type, sarr_el_ret(otherstrs,OSTR_TARGET), (int)(stLon->lntar), cs_lntar);
                  }
                  cs_des(&cs_lntar_absname);
               }
            } else {
               cs_appf(&line_new, "%*s%*s", (int)sarr_el_rets(otherstrs,OSTR_TARGET)->nc + 1, "", (int)(stLon->lntar), "");
               //+1 for char denoting type
            }
            break;
         case Format_props:
            if (stEntr->props.buf == NULL) { //no props for this entry
               cs_app(&line_new, "(none)");
            } else {
               cs_appf(&line_new, "(%s)", stEntr->props.buf);
            }
            break;
         case Format_size:
            cs_appf(&line_new, "%6s", stEntr->sizes[0].buf);
            break;
         case Format_size2:
            cs_appf(&line_new, "%6s", stEntr->sizes[1].buf);
            break;
         case Format_entrs:
            if (stEntr->type == 'd')
            {
               if (stEntr->n_entrs == 0) { //: couldn't read num of entires (possibly access denied)
                  cs_appf(&line_new, "%-*s", (int)(stLon->entrs), "?");
               } else {
                  cs_appf(&line_new, "%-*d", (int)(stLon->entrs), stEntr->n_entrs);
               }
            }
            else  //: all other types have no entries
            {
               cs_appf(&line_new, "%-*s", (int)(stLon->entrs), "");
            }
            break;
         case Format_atime:
            cs_appf(&line_new, "%s%s", sarr_el_ret(otherstrs,OSTR_ATIME), stEntr->times[0].buf);
            break;
         case Format_mtime:
            cs_appf(&line_new, "%s%s", sarr_el_ret(otherstrs,OSTR_MTIME), stEntr->times[1].buf);
            break;
         case Format_ctime:
            cs_appf(&line_new, "%s%s", sarr_el_ret(otherstrs,OSTR_CTIME), stEntr->times[2].buf);
            break;
         case Format_separ:
            cs_appf(&line_new, "%s", sarr_el_ret(otherstrs,OSTR_SEPAR));
            break;
         case Format_none: break;
         case format_count: ___Sentinel("format shouldn't contain 'count' value"); abort();
         default: ___Sentinel("wrong format value"); abort();
      }
         HandleErr(handle_err);
      stState.used[format_field] = true;
   }
   size_t len = strlen(line_new);
   //abc0
   while (line_new[len-1] == ' ') { --len; }
   line_new[len] = '\0';

    /*: Finish: */
  handle_succ:
   return line_new;

  handle_err:
   return NULL;
}




#endif /*- TFMAN_SRCREPTXT_REP_TEXT_AUX_H_INC -*/
