" ===============================================
" Prerequisities
if exists("g:loaded_tfmvi") || &cp | finish | endif
let g:loaded_tfmvi = "010"

let s:keepcpo = &cpo
set cpo&vim



"TODO:
"goto parent (ev. give lvls) + append input
"goto parent of file or link target
"rework settings changing
"repeat last action
"help window

let g:tfm_layout_presets = ":nameA,1@/,1@/tmp,2:nameB,1@/home,1@/root,2"


" ===============================================
" Settings
if !exists('g:tfm_act_tags_no_oper')
   let g:tfm_act_tags_no_oper = ["~","x","+","*"]
   let g:tfm_act_tags_oper = ["^","@",":",";","<>"]
   let g:tfm_act_tags_oper_dir = ["->","->*","=>","=>*","))","))*",">>",">>*"]
endif

if !exists('g:tfm_where_edit_win')
   let g:tfm_where_edit_win = 0
endif

if !exists('g:tfm_where_next_edit_win')
   let g:tfm_where_next_edit_win = 1
endif

if !exists('g:tfm_where_msg_win')
   let g:tfm_where_msg_win = 0
endif

if !exists('g:tfm_pair_window')
   let g:tfm_pair_window = 1
endif

if !exists('g:tfm_def_recurs_lvl')
   let g:tfm_def_recurs_lvl = 1
endif

if !exists('g:tfm_scan_options')
   " set default scan options
   let g:tfm_scan_options = []
   let g:tfm_scan_options_str = ""
endif

if !exists('g:tfm_parse_options')
   let g:tfm_parse_options = []
   let g:tfm_parse_options_str = ""
endif

if !exists('g:tfm_opt_indent')
   let g:tfm_opt_indent = []
   let g:tfm_opt_indent_str = ""
endif

if !exists('g:tfm_history_max')
   let g:tfm_history_max = 12
endif

" variables used:
   "g:tfm_where_edit_win      0-above 1-left
   "g:tfm_where_next_edit_win 0-below 1-right
   "g:tfm_where_msg_win       0-below 1-right
   "g:tfm_pair_window         1-incremental 0-decremental   direction to look for target window for actions triggered from user commands
   "
   "g:tfm_def_recurs_lvl      def. recursion lvl for actions that do not take recursion lvl as parameter
   "g:tfm_scan_options        options passed to tfman when scanning
   "g:tfm_parse_options       options passed to tfman when scanning
   "g:tfm_opt_indent          indentation used in parse and in scan mode
   "
   "w:tfm_edit_win            1 if win is edit win
   "w:tfm_msg_win             1 if win is msg win
   "
   "b:tfm_scan_history        list - names of scanned dirs
   "b:tfm_recurs_history      list - recursion depth of scanned dirs
   "b:tfm_history_idx         current place in history
   "g:tfm_history_max         max number of entries in history




" ===============================================
" COMMANDS and MAPPINGS

" SCAN
"
" 1st arg - file to scan, 2nd arg (optional) - recursion level
"
"if !exists(":Tsr")
command! -complete=file -nargs=* Tsr try | call Tfm_scan_repl(<f-args>) | catch | endtry
"endif

"if !exists(":Tsa")
command! -complete=file -nargs=* Tsa try | call Tfm_scan_app(<f-args>) | catch | endtry
"endif

"if !exists(":Tsw")
command! -complete=file -nargs=* Tsw try | call Tfm_scan_new_win(<f-args>) | catch | endtry
"endif

"if !exists(":Tst")
command! -complete=file -nargs=* Tst try | call Tfm_scan_new_tab(<f-args>) | catch | endtry
"endif


" SCAN - CURSOR
"
" 1st arg (optional) - line number in edit window, def. cursor line
"
"if !exists(":To")
command! -nargs=? To try | call Tfm_open_entry_num_repl(<f-args>) | catch | endtry
"endif

"if !exists(":Toa")
command! -nargs=? Toa try | call Tfm_open_entry_num_app(<f-args>) | catch | endtry
"endif

"if !exists(":Tow")
command! -nargs=? Tow try | call Tfm_open_entry_num_new_win(<f-args>) | catch | endtry
"endif

"if !exists(":Tot")
command! -nargs=? Tot try | call Tfm_open_entry_num_new_tab(<f-args>) | catch | endtry
"endif


" 1st arg (optional) - how many levels to go up in hierarchy, def. 1

"if !exists(":Tpar")
command! -nargs=? Tpar try | call Tfm_open_parent_dir_repl(<f-args>) | catch | endtry
"endif

"if !exists(":Tpara")
command! -nargs=? Tpara try | call Tfm_open_parent_dir_app(<f-args>) | catch | endtry
"endif

"if !exists(":Tparw")
command! -nargs=? Tparw try | call Tfm_open_parent_dir_new_win(<f-args>) | catch | endtry
"endif

"if !exists(":Tpart")
command! -nargs=? Tpart try | call Tfm_open_parent_dir_new_tab(<f-args>) | catch | endtry
"endif


" SCAN - HISTORY

" 1st arg (optional) - refresh with this recursion, def. previous recursion
"if !exists(":Tr")
command! -nargs=? Tr try | call Tfm_refresh(<f-args>) | catch | endtry
"endif

"if !exists(":Th")
command! -nargs=1 Th try | call Tfm_hist_to(<f-args>) | catch | endtry
"endif

"if !exists(":Tn")
command! -nargs=? Tn try | call Tfm_hist_next(<f-args>) | catch | endtry
"endif

"if !exists(":Tp")
command! -nargs=? Tp try | call Tfm_hist_prev(<f-args>) | catch | endtry
"endif

"if !exists(":The")
command! -nargs=0 The try | call Tfm_hist_echo() | catch | endtry
"endif


" PARSE
"
"if !exists(":Tsh")
command! -nargs=0 Tsh try | call Tfm_show() | catch | endtry
"endif

"if !exists(":T")
command! -nargs=0 T try | call Tfm_parse() | catch | endtry
"endif

"if !exists(":Te")
command! -nargs=0 Te try | call Tfm_make_current_msg_win() | catch | endtry
"endif

"if !exists(":Tact")
command! -nargs=+ Tact try | call Tfm_act_to_other_window(<f-args>) | catch | endtry
"endif

"if !exists(":Tactsh")
command! -nargs=+ Tactsh try | call Tfm_act_to_other_window_show(<f-args>) | catch | endtry
"endif


" USER-EASE

"if !exists(":Tins")
command! -complete=file -nargs=1 Tins try | call Tfm_uc_insert(<f-args>) | catch | endtry
"endif

"if !exists(":Temv")
command! -nargs=? Temv try | call Tfm_edit_mv(<f-args>) | catch | endtry
"endif

"if !exists(":Tecp")
command! -nargs=? Tecp try | call Tfm_edit_cp(<f-args>) | catch | endtry
"endif

"if !exists(":Temvo")
command! -nargs=? Temvo try | call Tfm_edit_mvo(<f-args>) | catch | endtry
"endif

"if !exists(":Tecpo")
command! -nargs=? Tecpo try | call Tfm_edit_cpo(<f-args>) | catch | endtry
"endif

"if !exists(":Term")
command! -nargs=? Term try | call Tfm_edit_rm(<f-args>) | catch | endtry
"endif

"if !exists(":Tecreat")
command! -nargs=0 Tecreat try | call Tfm_edit_create() | catch | endtry
"endif

"if !exists(":Tarm")
command! -nargs=? Tarm try | call Tfm_action_remove(<f-args>) | catch | endtry
"endif


" SETTINGS

"if !exists(":Toptv")
command! -nargs=0 Toptv try | call Tfm_opt_set(1, "") | catch | endtry
"endif

"if !exists(":Toptq")
command! -nargs=0 Toptq try | call Tfm_opt_set(2, "") | catch | endtry
"endif

"if !exists(":ToptI")
command! -nargs=1 ToptI try | call Tfm_opt_set(3, <f-args>) | catch | endtry
"endif

"if !exists(":ToptS")
command! -nargs=1 ToptS try | call Tfm_opt_set(4, <f-args>) | catch | endtry
"endif

"if !exists(":Topte")
command! -nargs=0 Topte try | call Tfm_opts_echo() | catch | endtry
"endif


" history:      refr, next, prev
" parse:        parse, show
" add tag:      s/hl[o], cp[o]. mv[o], rm, create
" operation now:rm...?
function! s:set_editwin_mappings ()
   noremap <silent> <buffer> <CR> :To<cr>
   noremap <silent> <buffer> - :<C-U>call Tfm_open_parent_dir_repl(v:count1)<cr>

   " count in refresh is recursion level
   noremap <silent> <buffer> <leader>} :<C-U>call Tfm_refresh(v:count1)<cr>
   noremap <silent> <buffer> <leader>] :<C-U>call Tfm_hist_next(v:count1)<cr>
   noremap <silent> <buffer> <leader>[ :<C-U>call Tfm_hist_prev(v:count1)<cr>

   noremap <silent> <buffer> <leader>m :<C-U>call Tfm_edit_mv(v:count1)<cr>
   noremap <silent> <buffer> <leader>c :<C-U>call Tfm_edit_cp(v:count1)<cr>
   noremap <silent> <buffer> <leader>M :<C-U>call Tfm_edit_mvo(v:count1)<cr>
   noremap <silent> <buffer> <leader>C :<C-U>call Tfm_edit_cpo(v:count1)<cr>
   noremap <silent> <buffer> <leader>r :<C-U>call Tfm_edit_rm(v:count1)<cr>
   noremap <silent> <buffer> <leader>t :call Tfm_edit_create()<cr>

   noremap <silent> <buffer> <leader>R :<C-U>call Tfm_action_rm(v:count1)<cr>

   noremap <silent> <buffer> <leader>S :Tsh<cr>
   noremap <silent> <buffer> <leader>P :T<cr>

   " insert mode completion, uses text after '>' char
   noremap <silent> <buffer> <C-F> <esc>T>yW:Tins <C-R>0
endfun








" ===============================================
" SCAN FUNCTIONS


" -----------------------------------------------
" User actions

" Make current widnow Tfman's edit window
function! Tfm_make_edit_win ()
  setlocal buftype=nofile
  setlocal bufhidden=hide
  setlocal noswapfile
  let w:tfm_edit_win = 1
  set filetype=tfm
  call s:set_editwin_mappings()
"syntax match tfm_name_ld_lsd "\v\[\s*(\w|\~|-|\+|\.|/|\*|\?|\}|\{)+\s*\]" contained containedin=tfm_line_dir
"syntax match tfm_name_ld_lsd "\v^.{-}\zs(\w|\~|-|\+|\.|/)+\ze" contained containedin=tfm_line_dir
"syntax match tfm_line_dir "\v^\s*#.*$"
  "let found_line = search('\v^\s*#.*$', 'cw')
  let found_line = search('\v^\s*#.*\[\s*(\w|\~|-|\+|\.|/|\*|\?|\}|\{)+\s*\].*$', 'cw')
  if (found_line != 0)
    normal! f[wyt]
    let dirname = @"
  else
    let dirname = "."
  endif
  call s:Hist_entry_app(dirname, 1)
endfun

" Scan given DIR.
" Send result to:
"  edit window - replace OR edit window - append OR new edit window OR new tabpage
" No edit window: create one
" 1st arg - dir name
" 2nd arg (optional) - recurs level, def. 1
"
function! Tfm_scan_repl (...)
   let file_entry = s:compute_file_entry(a:000)    " 0 -filename, 1 -recurs_lvl
   call s:Scan_repl(file_entry[0], file_entry[1])  " goto to edit win OR create + scan
endfun

function! Tfm_scan_app (...)
   let file_entry = s:compute_file_entry(a:000)    " 0 -filename, 1 -recurs_lvl
   call s:Scan_app(file_entry[0], file_entry[1])
endfun

function! Tfm_scan_new_win (...)
   let file_entry = s:compute_file_entry(a:000)    " 0 -filename, 1 -recurs_lvl
   call s:Edit_win_create_another()
   call s:Scan_repl(file_entry[0], file_entry[1])
endfun

function! Tfm_scan_new_tab (...)
   let file_entry = s:compute_file_entry(a:000)    " 0 -filename, 1 -recurs_lvl
   call s:Edit_win_create_newtab()
   call s:Scan_repl(file_entry[0], file_entry[1])
endfun

   function! s:compute_file_entry(vargs_list)
      let l = len(a:vargs_list)
      if (l == 0)
         call s:goto_edit_win_exit_if_no_history()
         return s:Hist_entry(b:tfm_history_idx)
      elseif (l == 1)
         return [a:vargs_list[0], 1]
      elseif (l == 2)
         return [a:vargs_list[0], a:vargs_list[1]]
      else
         call s:echo_crit("Wrong number of arguments supplied")
         call s:abort()
      endif
   endfun


" Open entry in specified line number. Dir scan, regular file edit, other file ignore.
" Send result to:
"  edit window - replace OR edit window - append OR new edit window OR new tabpage
" No edit window: do nothing
" 1st arg (optional) - line number
"
function! Tfm_open_entry_num_repl (...)
   call s:Edit_win_goto_or_exit()
   let uc_files = s:get_uc_files(a:000)
   call s:open_files(uc_files, 0)
endfun

function! Tfm_open_entry_num_app (...)
   call s:Edit_win_goto_or_exit()
   let uc_files = s:get_uc_files(a:000)
   call s:open_files(uc_files, 1)
endfun

function! Tfm_open_entry_num_new_win (...)
   call s:Edit_win_goto_or_exit()
   let uc_files = s:get_uc_files(a:000)
   call s:Edit_win_create_another()
   call s:open_files(uc_files, 0)
endfun

function! Tfm_open_entry_num_new_tab (...)
   call s:Edit_win_goto_or_exit()
   let uc_files = s:get_uc_files(a:000)
   call s:Edit_win_create_newtab()
   call s:open_files(uc_files, 0)
endfun

   function! s:get_uc_files (vargs_lnum)
      let l = len(a:vargs_lnum)
      if (l == 0)
         return s:Tfm_ret_line(line("."))  " returns list of resulting names
      elseif (l == 1)
         return s:Tfm_ret_line(a:vargs_lnum[0])
      else
         call s:echo_crit("Wrong number of arguments supplied for Tfm_open_entry_num_app()")
         call s:abort()
      endif
   endfun

   function! s:open_files (files, how_write)
      call s:open_file(a:files[0], a:how_write)
      for f in range(1,len(a:files)-1)
         call s:open_file(a:files[0], 1)
      endfor
   endfun

   function! s:open_file (file, how_write)
      let file = resolve(a:file)
      let type = getftype(file)

      if (type ==# "dir")
         if (a:how_write == 0)
            call s:Scan_repl(file, g:tfm_def_recurs_lvl)
         else
            call s:Scan_app(file, g:tfm_def_recurs_lvl)
         endif
      else
         call s:echo_info("not directory")
         return
      endif
   endfun


" Scan parent directory for current history entry.
" Send result to:
"  edit window - replace OR edit window - append OR new edit window OR new tabpage
" No edit window: do nothing
" 1st arg (optional) - parents hierarchy levels up
"
function! Tfm_open_parent_dir_repl (...)
   call s:Edit_win_goto_or_exit()
   let par_dir = s:get_parent_dir(a:000)
   call s:Scan_repl(par_dir, g:tfm_def_recurs_lvl)
endfun

function! Tfm_open_parent_dir_app (...)
   call s:Edit_win_goto_or_exit()
   let par_dir = s:get_parent_dir(a:000)
   call s:Scan_app(par_dir, g:tfm_def_recurs_lvl)
endfun

function! Tfm_open_parent_dir_new_win (...)
   call s:Edit_win_goto_or_exit()
   let par_dir = s:get_parent_dir(a:000)
   call s:Edit_win_create_another()
   call s:Scan_app(par_dir, g:tfm_def_recurs_lvl)
endfun

function! Tfm_open_parent_dir_new_tab (...)
   call s:Edit_win_goto_or_exit()
   let par_dir = s:get_parent_dir(a:000)
   call s:Edit_win_create_newtab()
   call s:Scan_app(par_dir, g:tfm_def_recurs_lvl)
endfun

   function! s:get_parent_dir (vargs_lvls)
      if (!exists('b:tfm_history_idx'))
         call s:abort()
      endif

      let hist_entry = s:Hist_entry(b:tfm_history_idx)

      let l = len(a:vargs_lvls)

      if (l == 0)
         let par_dir = fnamemodify(hist_entry[0], ":h")
      elseif (l == 1)
         let par_dir = hist_entry[0]
         let lvls = a:vargs_lvls[0]
         while (lvls > 0)
            let par_dir = fnamemodify(par_dir, ":h")
            let lvls = lvls - 1
         endwhile
      else
         call s:echo_crit("Wrong number of arguments supplied for Tfm_open_parent_dir_app()")
         call s:abort()
      endif
      return par_dir
   endfun


" Scan entries from history:
"  current (refresh), at specified index, next, previous
" Replace edit window with result.
" No edit buffer: create one
" No history yet: do nothing
"
function! Tfm_refresh (...)
   if (a:0 == 0)
      call s:goto_edit_win_exit_if_no_history()
      call s:Scan_hist(b:tfm_history_idx, 0)
   elseif (a:0 == 1)
      call s:goto_edit_win_exit_if_no_history()
      let hist_entry = s:Hist_entry(b:tfm_history_idx)
      1,$d
      call s:Scan(hist_entry[0], a:1)
   else
      call s:echo_crit("Wrong number of arguments supplied")
      call s:abort()
   endif
endfun

function! Tfm_hist_to (hist_idx)
   call s:goto_edit_win_exit_if_no_history()
   call s:scan_hist_at_idx(a:hist_idx)
endfun

function! Tfm_hist_next (...)
   call s:goto_edit_win_exit_if_no_history()

   if (a:0 == 0)
      let idx = b:tfm_history_idx + 1
   elseif (a:0 == 1)
      let idx = b:tfm_history_idx + a:1
   else
      call s:echo_crit("Wrong number of arguments supplied")
      call s:abort()
   endif

   call s:scan_hist_at_idx(idx)
endfun

function! Tfm_hist_prev (...)
   call s:goto_edit_win_exit_if_no_history()

   if (a:0 == 0)
      let idx = b:tfm_history_idx - 1
   elseif (a:0 == 1)
      let idx = b:tfm_history_idx - a:1
   else
      call s:echo_crit("Wrong number of arguments supplied for")
      call s:abort()
   endif

   call s:scan_hist_at_idx(idx)
endfun

   function! s:goto_edit_win_exit_if_no_history ()
      call s:Edit_win_goto_or_exit()
      if (!exists('b:tfm_history_idx'))
         call s:echo_info("No history yet")
         call s:abort()
      endif
   endfun

   function! s:scan_hist_at_idx (hist_idx)
      " only if we are not beyond last or before 0 index
      if (a:hist_idx <= (len(b:tfm_scan_history) - 1) && a:hist_idx >= 0)
         let b:tfm_history_idx = a:hist_idx
         call s:Scan_hist(a:hist_idx, 0)
      else
         call s:echo_info("Wrong history index")
         call s:abort()
      endif
   endfun

function! Tfm_hist_echo ()
   call s:Edit_win_goto_or_exit()
   for i in range(0,len(b:tfm_scan_history)-1)
      if (i == b:tfm_history_idx)
         echo "[" . i . "]: " . b:tfm_scan_history[i] . "," . b:tfm_recurs_history[i]
      else
         echo " " . i . " : " . b:tfm_scan_history[i] . "," . b:tfm_recurs_history[i]
      endif
   endfor
endfun


" -----------------------------------------------
" Basic operations

" Scan given DIR and place as new in history
" Result: replace current buffer or append
" No edit buffer: create one
"
function! s:Scan_repl (dir_name, recursion_lvl)
   call s:Edit_win_goto_or_create()
   1,$d
   call s:Scan(a:dir_name, a:recursion_lvl)
   call s:Hist_entry_app(a:dir_name, a:recursion_lvl)
endfun

function! s:Scan_app (dir_name, recursion_lvl)
   call s:Edit_win_goto_or_create()
   normal! G
   call s:Scan(a:dir_name, a:recursion_lvl)
endfun

" Scan specified history entry
" Result: replace or append - as specified
"
function! s:Scan_hist (hist_idx, how_write_result)
   " clear buffer if specified
   if (a:how_write_result == 0)
      1,$d
   else
      normal! G
   endif

   let hist_entry = s:Hist_entry(a:hist_idx)
   call s:Scan(hist_entry[0], hist_entry[1])
   echom "scan: " . hist_entry[0] . ' '  . ' ' . hist_entry[1]
endfun

   " Scan given DIR with specified recursion level
   "
   function! s:Scan (dir_name, recursion_lvl)
      let cur_pos = getpos(".")
      let user_opts = g:tfm_scan_options_str . " " . g:tfm_opt_indent_str
      exec "read !tfman -M=scan -R=" . a:recursion_lvl . " " . user_opts . " " . shellescape(a:dir_name, 1)
      call setpos(".", cur_pos)
      call s:Hist_show_in_buffer()
   endfun





" ===============================================
" WINDOW FUNCTIONS


" -----------------------------------------------
" Edit windows

function! s:Edit_win_goto_or_exit ()
   let win_num = s:Edit_win_goto()
   if (win_num == 0)
      call s:echo_info ("No tfman edit window")
      call s:abort()
   endif
   return win_num
endfun


function! s:Edit_win_goto_or_create ()
   let win_num = s:Edit_win_goto()
   if (win_num == 0)
      let win_num = s:Edit_win_create()
   endif
   return win_num
endfun


function! s:Edit_win_goto ()
   if (exists("w:tfm_edit_win"))
      return winnr()
   endif
   for w in range(1, winnr('$'))
      if getwinvar(w, 'tfm_edit_win')
         exec w . "wincmd w"
         return w
      endif
   endfor
   return 0
endfun


function! s:Edit_win_goto_other_or_exit ()
   let win_num = s:Edit_win_goto_other()
   if (win_num == 0)
      call s:echo_info ("No other tfman edit window")
      call s:abort()
   endif
   return win_num
endfun

function! s:Edit_win_goto_other ()
   if (!exists("w:tfm_edit_win"))
      call s:echo_info ("Current window is not tfman edit window")
      call s:abort()
   endif

   let cur_win = winnr()
   let last_win = winnr('$')

   if (g:tfm_pair_window == 0)   "decremental

      if (cur_win > 1)
         for w in range(cur_win - 1, 1, -1)
            if getwinvar(w, 'tfm_edit_win')
               exec w . "wincmd w"
               return w
            endif
         endfor
      endif
      if (cur_win < last_win)
         for w in range(last_win, cur_win + 1, -1)
            if getwinvar(w, 'tfm_edit_win')
               exec w . "wincmd w"
               return w
            endif
         endfor
      endif

   elseif (g:tfm_pair_window == 1)  "incremental

      if (cur_win < last_win)
         for w in range(cur_win + 1, last_win)
            if getwinvar(w, 'tfm_edit_win')
               exec w . "wincmd w"
               return w
            endif
         endfor
      endif
      if (cur_win > 1)
         for w in range(1, cur_win - 1)
            if getwinvar(w, 'tfm_edit_win')
               exec w . "wincmd w"
               return w
            endif
         endfor
      endif

   else
      call s:echo_crit("Wrong g:tfm_pair_window value")
      call s:abort()
   endif

   return 0
endfun


function! s:Edit_win_create ()
   if (g:tfm_where_edit_win == 0)
      new
   else
      vnew
   endif
   call Tfm_make_edit_win()
   return winnr()
endfun


function! s:Edit_win_create_another ()
   call s:Edit_win_goto_or_exit()

   if (g:tfm_where_next_edit_win == 0)
      belowright new
   else
      belowright vnew
   endif
   call Tfm_make_edit_win()
   return winnr()
endfun


function! s:Edit_win_create_newtab ()
   tabnew
   call s:Edit_win_create()
   only
endfun




" -----------------------------------------------
" Message windows

function! s:Msg_win_goto ()
   if (exists("w:tfm_msg_win"))
      return winnr()
   endif
   for w in range(1, winnr('$'))
      if getwinvar(w, 'tfm_msg_win')
         exec w . "wincmd w"
         return w
      endif
   endfor
   return 0
endfun


function! s:Msg_win_create ()
   if (g:tfm_where_msg_win == 0)
      belowright new
   else
      belowright vnew
   endif
   call Tfm_make_current_msg_win()
   return winnr()
endfun


function! Tfm_make_current_msg_win ()
   setlocal buftype=nofile
   setlocal bufhidden=hide
   setlocal noswapfile
   let w:tfm_msg_win = 1
   set filetype=tfm
endfun




" ===============================================
" PARSE FUNCTIONS

function! Tfm_show ()

   " goto edit win or error
   let edit_win_num = s:Edit_win_goto_or_exit()

   " capture output and put it in tfman message window
   let user_opts = g:tfm_opt_indent_str
   let buf_contents = join(getline('1','$'), "\n")
   let out = system('echo "' . buf_contents . '" | tfman -s ' . user_opts)
   "let out = system("tfman -s " . user_opts . " " . shellescape(expand("%"), 1))

   let msg_win_num = s:Msg_win_goto()
   if (msg_win_num == 0)
      call s:Msg_win_create()
   endif

   call append(line('$'), ['','','::: ' . strftime("%H:%M:%S") .': tfman window number ' . edit_win_num . ':', '-------------'])
   exec line('$') . "put =out"
   normal! G
   wincmd p

endfun

function! Tfm_parse ()

   " goto edit win or error
   let edit_win_num = s:Edit_win_goto_or_exit()

   " capture output and put it in tfman message window
   let user_opts = g:tfm_parse_options_str . " " . g:tfm_opt_indent_str
   let buf_contents = join(getline('1','$'), "\n")
   let out = system('echo "' . buf_contents . '" | tfman -n ' . user_opts)
   "let out = system("tfman -n " . user_opts . " " . shellescape(expand("%"), 1))

   let msg_win_num = s:Msg_win_goto()
   if (msg_win_num == 0)
      call s:Msg_win_create()
   endif

   call append(line('$'), ['','','::: ' . strftime("%H:%M:%S") .': tfman executed actions from window number ' . edit_win_num . ':', '-------------'])
   exec line('$') . "put =out"
   normal! G
   wincmd p
   call Tfm_refresh()

endfun

function! Tfm_act_to_other_window (line_start, line_end, act_tag)
   call s:append_acts_to_lines(a:line_start, a:line_end, a:act_tag)
   call Tfm_parse()
endfun

function! Tfm_act_to_other_window_show (line_start, line_end, act_tag)
   call s:append_acts_to_lines(a:line_start, a:line_end, a:act_tag)
   call Tfm_show()
   call Tfm_refresh()
endfun

   function! s:append_acts_to_lines (line_start, line_end, act_tag)

      let found = index(g:tfm_act_tags_no_oper, a:act_tag)
      if (found != -1)  " no oper
         let target_name = ""
      endif

      let found = index(g:tfm_act_tags_oper, a:act_tag)
      if (found != -1)  " oper
         let target_name = ""
         return
      endif

      let found = index(g:tfm_act_tags_oper_dir, a:act_tag)
      if (found != -1)  " oper dir
         call s:Edit_win_goto_other_or_exit ()
         let target_name = b:tfm_scan_history[b:tfm_history_idx]
         wincmd p
      endif

      let action = a:act_tag . target_name
      for l in range(a:line_start, a:line_end)
         call setline(l, getline(l) . " " . action)
      endfor

   endfun




" ===============================================
" History management

function! s:Hist_entry_app (dir_name, recursion_lvl)
   " create hist vars if non-exist yet
   if (!exists("b:tfm_history_idx"))
      let b:tfm_history_idx = 0
      let b:tfm_scan_history = [a:dir_name]
      let b:tfm_recurs_history = [a:recursion_lvl]
   else
      " add new entry
      let b:tfm_history_idx = b:tfm_history_idx + 1
      call insert(b:tfm_scan_history, a:dir_name, b:tfm_history_idx)
      call insert(b:tfm_recurs_history, a:recursion_lvl, b:tfm_history_idx)
      " remove first entry if max hist exceeded
      if (len(b:tfm_scan_history) > g:tfm_history_max)
         call remove(b:tfm_scan_history, 0)
         call remove(b:tfm_recurs_history, 0)
         let b:tfm_history_idx = b:tfm_history_idx - 1
      endif
   endif
   call s:Hist_show_in_buffer()
endfun

function! s:Hist_entry (idx)
   let ret = [b:tfm_scan_history[a:idx], b:tfm_recurs_history[a:idx]]
   return ret
endfun

function! s:Hist_idx_set (idx)
   let b:tfm_history_idx = a:idx
endfun


function! s:Hist_show_in_buffer ()
   let cur_pos = getpos(".")

   let pat = "^::::"
   let line = search(pat, "cwn")
   if (line == 0)
      let line = 1
      call append(1,"")
   endif

   let text = ""
   let text2 = ""

   if (exists("b:tfm_scan_history"))
      for i in range(0,len(b:tfm_scan_history)-1)
         if (i == b:tfm_history_idx)
            let text2 = text2 . "  [" . i . ":" . b:tfm_scan_history[i] . "," . b:tfm_recurs_history[i] . "]"
            let text = text . text2
         else
            let text = text . "  " . i . ":" . b:tfm_scan_history[i] . "," . b:tfm_recurs_history[i]
         endif
      endfor
   endif
   call setline(line, "::::" . text)
   call setline(line+1, "...." . text2)
   call setpos(".", cur_pos)
endfun




" ===============================================
" CHANGE SETTINGS
function! Tfm_opt_set (opt_num, value)
   if (a:opt_num == 1)     "verbose
      call s:set_scan_opt("-v", "")
   elseif (a:opt_num == 2)     "quiet
      call s:set_scan_opt("-q", "")
   elseif (a:opt_num == 3)     "indentation
      call s:set_opt_indent(a:value)
   elseif (a:opt_num == 4)     "sort
      call s:set_scan_opt("-S", a:value)
   else
      call s:echo_crit("Wrong number of arguments supplied")
      call s:abort()
   endif
endfun


   function! s:set_scan_opt (opt_name, value)
      let g:tfm_scan_options = deepcopy(s:set_opt(copy(g:tfm_scan_options), a:opt_name, a:value))   " parse opts
      let g:tfm_scan_options_str = join(g:tfm_scan_options)
   endfun


   function! s:set_parse_opt (opt_name, value)
      let g:tfm_parse_options = deepcopy(s:set_opt(copy(g:tfm_parse_options), a:opt_name, a:value))   " parse opts
      let g:tfm_parse_options_str = join(g:tfm_parse_options)
   endfun


   function! s:set_opt_indent (value)
      let g:tfm_opt_indent = deepcopy(s:set_opt(copy(g:tfm_opt_indent), a:opt_name, a:value))   " parse opts
      let g:tfm_opt_indent_str = join(g:tfm_opt_indent)
   endfun


   " value ""     - toggle option      if present - remove, not present - set (with empty value)
   " value "val"  - set option         if present - change val, not present - add option
   function! s:set_opt (opts_list, opt_name, value)
      let res_list = []
      let found = 0
      for el in range(0, len(a:opts_list)-1)
         let idx = stridx(a:opts_list[el], a:opt_name)
         if (idx == -1) " different opt
            call add(res_list, a:opts_list[el])
         else           " opt found, we remove it
            let found = 1
         endif
      endfor

      if (!empty(a:value) && a:value !=# "-")
         call add(res_list, a:opt_name . " " . a:value)
      else
         if (found == 0)       " no opt found
            call add(res_list, a:opt_name)
         endif
      endif

      return res_list
   endfun


function! Tfm_opts_echo ()
   echo "scan options: " . g:tfm_scan_options_str
   echo "parse options: " . g:tfm_parse_options_str
   echo "indent option: " . g:tfm_opt_indent_str
endfun




" ===============================================
" USER-EASE FUNCTIONS
function! Tfm_uc_insert (str)
   exec "normal! a" . a:str
endfun

" 0 args: current line, 1 arg: current line + N lines, 2 args: line N and M lines
function! Tfm_edit_mv (...)
  let lines = s:compute_lines_to_edit(a:000)
  for lnum in range(lines[0], lines[1])
    call cursor(lnum, 1)
    normal! f[wyt]f]a >>
    normal! p
  endfor
  call cursor(lines[0], 1)
  normal! f>E
  return
endfun

" like above
function! Tfm_edit_cp (...)
  let lines = s:compute_lines_to_edit(a:000)
  for lnum in range(lines[0], lines[1])
    call cursor(lnum, 1)
    normal! f[wyt]f]a ))
    normal! p
  endfor
  call cursor(lines[0], 1)
  normal! f)E
  return
endfun

" like above
function! Tfm_edit_mvo (...)
  let lines = s:compute_lines_to_edit(a:000)
  for lnum in range(lines[0], lines[1])
    call cursor(lnum, 1)
    normal! f[wyt]f]a >>*
    normal! p
  endfor
  call cursor(lines[0], 1)
  normal! f>E
  return
endfun

" like above
function! Tfm_edit_cpo (...)
  let lines = s:compute_lines_to_edit(a:000)
  for lnum in range(lines[0], lines[1])
    call cursor(lnum, 1)
    normal! f[wyt]f]a ))*
    normal! p
  endfor
  call cursor(lines[0], 1)
  normal! f)E
  return
endfun

" add tag from current line across a:1 (def 1) lines
function! Tfm_edit_rm (...)
  let nlines = a:0 > 0 ? a:1 : 1
  let line_beg = line(".")
  let line_end = line_beg + nlines - 1
  for lnum in range(line_beg, line_end)
    call cursor(lnum, 1)
    normal! f a* 
  endfor
  call cursor(line_beg, 1)
  return
endfun

" like above
function! Tfm_edit_create ()
  normal! o
  normal! a ~ 
  startinsert!
  return
endfun

" TODO: actions
" perform action now
function! Tfm_action_rm(...)
   "call Tfm_edit_rm(a:000)

   "if (a:0 == 0)  " if only current line to remove
      "call Tfm_parse()
   "endif
   return
endfun


   function! s:compute_lines_to_edit (vargs)
      let l = len(a:vargs)
      if (l == 0)
         let start_line = line('.')
         let end_line = start_line
      elseif (l == 1)
         let start_line = line('.')
         let end_line = start_line + a:vargs[0] - 1
      elseif (l == 2)
         let start_line = a:vargs[0]
         let end_line = start_line + a:vargs[1] - 1
      else
         call s:echo_crit("Wrong number of arguments supplied")
         call s:abort()
      endif
      return [start_line, end_line]
   endfun


" ===============================================
" HELPER FUNCTIONS

function! s:Tfm_ret_line (line)
   let user_opts = g:tfm_opt_indent_str
   let buf_contents = join(getline('1','$'), "\n")
   let out = system('echo "' . buf_contents . '" | tfman -N -l=' . a:line . ' ' . user_opts)
   "let out = system("tfman -N -l " . a:line . " " . user_opts . " " . shellescape(expand("%"), 1))

   if (v:shell_error != 0)
      let msg_win_num = s:Msg_win_goto()
      if (msg_win_num == 0)
         call s:Msg_win_create()
      endif

      call append(line('$'), ':: FAILED:')
      exec line('$') . "put =out"
      normal! G
      wincmd p

      return [""]
   endif
   return split(out, "\n")
endfun




" ===============================================
" DEBUG/ERROR FUNCTIONS

function! s:echo_crit (msg)
   echom ":: tfmvi [CRIT]: " . a:msg
endfun

function! s:echo_warn (msg)
   echom ":: tfmvi [WARN]: " . a:msg
endfun

function! s:echo_info (msg)
   echom ":: tfmvi: " . a:msg
endfun

function! s:abort ()
   throw "aborting"
   "exec ":silent! finish"
endfun




let &cpo= s:keepcpo
unlet s:keepcpo
