if exists("b:current_syntax")
   finish
endif



syntax match tfm_line_normal "\v^.*$"




" HISTORY DISPLAY
syntax region tfm_hist start=/\v^::::/ end=/\v$/ contains=tfm_hist_cur
syntax region tfm_hist_cur start=/\[/ end=/\]/ contained
syntax region tfm_hist_cur2 start=/\v^\.\.\.\./ end=/\v$/



" EFFECTIVE LINE
syntax match tfm_line_active "\v^((\s*\|)|(\s+)).*$"
syntax match tfm_line_prior "\v^\s*\$.*$"
syntax match tfm_line_dir "\v^\s*#.*$"
syntax match tfm_grp "\v^\s*(\{|\}|\{\{|\}\}).*$"
syntax match tfm_pars_end "\v^\s*END\s*$"
syntax match tfm_el "\v(\s+|\||\$|\#|\%|\])EL(\s+|\[)" contained containedin=ALL




" TYPE of ACTIVE and PRIORITY LINE
" type must be first word after name to be recognized
"let s:file_name = '(\w|\.|/|\*|\?|\}|\{|\[|\])+'
"let s:acts_nooper = '(\*|\+|\~|EL|\.|\=|\.\=|\|\||\&|\&\&)'

"let s:space_start = '^\s+(\*\s+)*'
"let s:line_start = '^\s*(\$|\|)\s*'
"let s:bracket_start = '^\s+\[\s*'
"let s:bracket_end = '\s*\]'
"let s:line_bracket_start = '^\s*(\$|\|)\s*\[\s*'




" ACTIVE and PRIORITY LINE
"syntax match tfm_type_dir_la "\v^.*(\w|\.|/|\*|\?|\}|\{|\[|\])+.*\s+\^?d(\s|$)+.*$" contained containedin=tfm_line_active
syntax match tfm_type_dir_la "\v^.{-}\s+\^?d(\s|$)+.*$" contained containedin=tfm_line_active
syntax match tfm_type_dir_lp "\v^.{-}\s+\^?d(\s|$)+.*$" contained containedin=tfm_line_prior
syntax match tfm_type_dir_ln "\v^.{-}\s+\^?d(\s|$)+.*$" contained containedin=tfm_line_normal
syntax match tfm_type_sl_la "\v^.{-}\s+\^?l(\s|$)+.*$" contained containedin=tfm_line_active
syntax match tfm_type_sl_lp "\v^.{-}\s+\^?l(\s|$)+.*$" contained containedin=tfm_line_prior
syntax match tfm_type_sl_ln "\v^.{-}\s+\^?l(\s|$)+.*$" contained containedin=tfm_line_normal
syntax match tfm_type_reg_la "\v^.{-}\s+\^?-(\s|$)+.*$" contained containedin=tfm_line_active
syntax match tfm_type_reg_lp "\v^.{-}\s+\^?-(\s|$)+.*$" contained containedin=tfm_line_prior
syntax match tfm_type_reg_ln "\v^.{-}\s+\^?-(\s|$)+.*$" contained containedin=tfm_line_normal
syntax match tfm_type_other_la "\v^.{-}\s+\^?(s|f|c|b)(\s|$)+.*$" contained containedin=tfm_line_active
syntax match tfm_type_other_lp "\v^.{-}\s+\^?(s|f|c|b)(\s|$)+.*$" contained containedin=tfm_line_prior
syntax match tfm_type_other_ln "\v^.{-}\s+\^?(s|f|c|b)(\s|$)+.*$" contained containedin=tfm_line_normal

syntax match tfm_name_dir "\v\[\s*(\w|\~|-|\+|\.|/|\*|\?|\}|\{)+\s*\]" contained containedin=tfm_type_dir_la,tfm_type_dir_lp,tfm_type_dir_ln
syntax match tfm_name_dir "\v^.{-}\zs(\w|\~|-|\+|\.|/)+\ze" contained containedin=tfm_type_dir_la,tfm_type_dir_lp,tfm_type_dir_ln
syntax match tfm_name_sl "\v\[\s*(\w|\~|-|\+|\.|/|\*|\?|\}|\{)+\s*\]" contained containedin=tfm_type_sl_la,tfm_type_sl_lp,tfm_type_sl_ln
syntax match tfm_name_sl "\v^.{-}\zs(\w|\~|-|\+|\.|/)+\ze" contained containedin=tfm_type_sl_la,tfm_type_sl_lp,tfm_type_sl_ln
syntax match tfm_name_reg "\v\[\s*(\w|\~|-|\+|\.|/|\*|\?|\}|\{)+\s*\]" contained containedin=tfm_type_reg_la,tfm_type_reg_lp,tfm_type_reg_ln
syntax match tfm_name_reg "\v^.{-}\zs(\w|\~|-|\+|\.|/)+\ze" contained containedin=tfm_type_reg_la,tfm_type_reg_lp,tfm_type_reg_ln
syntax match tfm_name_other "\v\[\s*(\w|\~|-|\+|\.|/|\*|\?|\}|\{)+\s*\]" contained containedin=tfm_type_other_la,tfm_type_other_lp,tfm_type_other_ln
syntax match tfm_name_other "\v^.{-}\zs(\w|\~|-|\+|\.|/)+\ze" contained containedin=tfm_type_other_la,tfm_type_other_lp,tfm_type_other_ln


" DIR LINE
syntax match tfm_name_ld_lsd "\v\[\s*(\w|\~|-|\+|\.|/|\*|\?|\}|\{)+\s*\]" contained containedin=tfm_line_dir
syntax match tfm_name_ld_lsd "\v^.{-}\zs(\w|\~|-|\+|\.|/)+\ze" contained containedin=tfm_line_dir


" OPERATORS
syntax match tfm_act_nooper "\v(^|^\s*(\$|\||\#|\%)|\s+)\zs(\+|\*|\~|x|\.\=|\.|\=|\|\||\&\&|\&)" contained containedin=tfm_line_dir,tfm_type_sl_la,tfm_type_sl_lp,tfm_type_other_la,tfm_type_other_lp,tfm_type_reg_la,tfm_type_reg_lp,tfm_type_dir_la,tfm_type_dir_lp,tfm_line_active,tfm_grp
syntax match tfm_act_oper_word "\v(^|^\s*(\$|\||\#|\%)|\s+)\zs(\^|\@|:|;)(\w|-)+" contained containedin=tfm_line_dir,tfm_type_sl_la,tfm_type_sl_lp,tfm_type_other_la,tfm_type_other_lp,tfm_type_reg_la,tfm_type_reg_lp,tfm_type_dir_la,tfm_type_dir_lp,tfm_line_active,tfm_grp
syntax match tfm_act_oper_file "\v(-\>|-\>\*|\=\>|\=\>\*|\)\)|\)\)\*|\>\>|\>\>\*)(\w|\.|/)+" contained containedin=tfm_line_dir,tfm_type_sl_la,tfm_type_sl_lp,tfm_type_other_la,tfm_type_other_lp,tfm_type_reg_la,tfm_type_reg_lp,tfm_type_dir_la,tfm_type_dir_lp,tfm_line_active,tfm_grp


" SL TARGETS
syntax match tfm_sl_tard "\vd_\>\f+" contained containedin=ALL
syntax match tfm_sl_tarr "\v-_\>\f+" contained containedin=ALL
syntax match tfm_sl_tarl "\vl_\>\f+" contained containedin=ALL
syntax match tfm_sl_taro "\v(s|f|c|b)_\>\f+" contained containedin=ALL
syntax match tfm_sl_tar_ne "\v!!\>\f+" contained containedin=ALL

syntax match tfm_sl_pointer "\v((d|-|l|s|f|c|b)_\>)|(\!\!\>)" contained containedin=tfm_sl_tard,tfm_sl_tarr,tfm_sl_tarl,tfm_sl_taro,tfm_sl_tar_ne




hi tfm_hist           ctermfg=127 guifg=#af00af
hi tfm_hist_cur       ctermfg=134 guifg=#af5fdf
hi tfm_hist_cur2      ctermfg=134 guifg=#af5fdf

hi tfm_name_dir       ctermfg=12 guifg=#0000ff
hi tfm_name_sl        ctermfg=14 guifg=#00ffff
hi tfm_name_reg       ctermfg=34 guifg=#00af00
hi tfm_name_other     ctermfg=5 guifg=#800080

hi tfm_grp            ctermfg=214 guifg=#ffaf00
hi tfm_pars_end       ctermfg=255 ctermbg=9 guifg=#eeeeee guibg=#ff0000
hi default link tfm_el tfm_pars_end

hi default link tfm_sl_tarl tfm_name_sl
hi default link tfm_sl_tard tfm_name_dir
hi default link tfm_sl_tarr tfm_name_reg
hi default link tfm_sl_taro tfm_name_other
hi tfm_sl_pointer    ctermfg=94 guifg=#875f00
hi tfm_sl_tar_ne     ctermfg=1 guifg=#000000

hi tfm_act_nooper    ctermfg=11 guifg=#ffff00
hi tfm_act_oper_word ctermfg=11 guifg=#ffff00
hi tfm_act_oper_file ctermfg=11 guifg=#ffff00


hi tfm_line_dir       ctermfg=202 guifg=#ff5f00
hi tfm_name_ld_lsd    ctermfg=32 guifg=#0000af

hi tfm_type_dir_la      ctermfg=35 guifg=#00af5f
hi tfm_type_dir_lp      ctermfg=47 guifg=#00ff5f
hi tfm_type_dir_ln      ctermfg=240 guifg=#585858
hi tfm_type_reg_la      ctermfg=35 guifg=#00af5f
hi tfm_type_reg_lp      ctermfg=47 guifg=#00ff5f
hi tfm_type_reg_ln      ctermfg=240 guifg=#585858
hi tfm_type_sl_la       ctermfg=35 guifg=#00af5f
hi tfm_type_sl_lp       ctermfg=47 guifg=#00ff5f
hi tfm_type_sl_ln       ctermfg=240 guifg=#585858
hi tfm_type_other_la    ctermfg=35 guifg=#00af5f
hi tfm_type_other_lp    ctermfg=47 guifg=#00ff5f
hi tfm_type_other_ln    ctermfg=240 guifg=#585858





let b:current_syntax = "tfman"



" REMAINDER
" priority: keyword, match+region (defined last has priority)
"syntax keyword SYN_GRP KWORD KWORD KWORD [syn-arguments]
"SYN_GRP    - group syntax items, linked to hi group
"KWORD      - "ab[brev]", all chars must be in 'iskeyword', may define many times in different 'containded'
"syn-arguments - conceal:may be concealed with 'conceallevel', concealends:conceal only start and end, cchar:char shown in place of concealed item
"     contained:recognize only in items that contain it, contains=GRP,GRP/PATTERN/ALL/ALLBUT,GRP/TOP/CONTAINED item may contain GRP, containedin=GRP,GRP, transparent:take hi of containig item
"     oneline: region must match in one line, however contained items may cross line end
"     nextgroup=GRP,GRP: try it after current region ends, if none match continue normal hi, skipwhite/nl/empty: skip it when matchin nextgroup
"
"syntax match SYN_GRP [excludenl] PATTERN [syn-arguments]
" excludenl - pattern with '$' will not extend containing match or region
" PATTERN   - regexp
" . each match consumes piece of file and it will not be hi later by other group - define larger grp first

" syntax region SYN_GRP [syn-arguments]
" start=/RE/   - start region
" skip=/RE/    - do not end region with this pattern
" end=/RE/     - start region
